package com.simuwang.manage.service.impl;

import com.simuwang.base.mapper.daq.CompanyReportFrequencyMapper;
import com.simuwang.base.mapper.daq.FundInfoMapper;
import com.simuwang.base.mapper.daq.FundReportFrequencyMapper;
import com.simuwang.base.pojo.dos.CompanyReportFrequencyDO;
import com.simuwang.base.pojo.dos.FundReportFrequencyDO;
import com.simuwang.base.pojo.vo.CompanyIdVO;
import com.simuwang.base.pojo.vo.CompanyReportFrequencyVO;
import com.simuwang.manage.service.CompanyReportFrequencyService;
import com.simuwang.shiro.utils.UserUtils;
import com.smppw.common.pojo.ResultVo;
import com.smppw.common.pojo.enums.status.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Service
public class CompanyReportFrequencyServiceImpl implements CompanyReportFrequencyService {
    @Autowired
    private CompanyReportFrequencyMapper companyReportFrequencyMapper;
    @Autowired
    private FundReportFrequencyMapper  fundReportFrequencyMapper;
    @Autowired
    private FundInfoMapper fundInfoMapper;

    @Override
    public ResultVo saveCompanyReportFrequency(CompanyReportFrequencyVO companyReportFrequencyVO) {
        ResultVo vo = new ResultVo(ResultCode.SAVE_SUCCESS.getCode());
        CompanyReportFrequencyDO companyReportFrequencyDO = new CompanyReportFrequencyDO();
        companyReportFrequencyDO.setCompanyId(companyReportFrequencyVO.getCompanyId());
        companyReportFrequencyDO.setAssetFrequency(companyReportFrequencyVO.getAssetFrequency());
        companyReportFrequencyDO.setNavFrequency(companyReportFrequencyVO.getNavFrequency());
        companyReportFrequencyDO.setValuationFrequency(companyReportFrequencyVO.getValuationFrequency());
        companyReportFrequencyDO.setUpdateTime(new Date());
        companyReportFrequencyDO.setFrequencyRemark(companyReportFrequencyVO.getFrequencyRemark());
        companyReportFrequencyDO.setCreatorId(UserUtils.getLoginUser().getUserId());
        companyReportFrequencyDO.setUpdaterId(UserUtils.getLoginUser().getUserId());
        CompanyReportFrequencyDO oldFrequency = companyReportFrequencyMapper.getFrequencyByCompanyId(companyReportFrequencyVO.getCompanyId());
        if(oldFrequency == null){
            companyReportFrequencyDO.setCreateTime(new Date());
            companyReportFrequencyDO.setIsvalid(1);
            companyReportFrequencyMapper.insert(companyReportFrequencyDO);
        }else{
            companyReportFrequencyDO.setId(oldFrequency.getId());
            companyReportFrequencyMapper.updateById(companyReportFrequencyDO);
        }
        //设置公司旗下基金的数据频率，已经存在的不做覆盖
        List<String> fundIdList = fundInfoMapper.getFundIdByCompanyId(companyReportFrequencyVO.getCompanyId());
        if(!fundIdList.isEmpty()){
            List<String> fundReportFrequencyIdList = fundReportFrequencyMapper.selectFundId(fundIdList);
            List<FundReportFrequencyDO> fundReportFrequencyDOList = new ArrayList<FundReportFrequencyDO>();
            for (String fundId : fundIdList) {
                if(fundReportFrequencyIdList.contains(fundId)){
                    continue;
                }
                FundReportFrequencyDO fundReportFrequencyDO = new FundReportFrequencyDO();
                fundReportFrequencyDO.setCreateTime(new Date());
                fundReportFrequencyDO.setFundId(fundId);
                fundReportFrequencyDO.setAssetFrequency(companyReportFrequencyVO.getAssetFrequency());
                fundReportFrequencyDO.setNavFrequency(companyReportFrequencyVO.getNavFrequency());
                fundReportFrequencyDO.setValuationFrequency(companyReportFrequencyVO.getValuationFrequency());
                fundReportFrequencyDO.setUpdateTime(new Date());
                fundReportFrequencyDO.setFrequencyRemark(companyReportFrequencyVO.getFrequencyRemark());
                fundReportFrequencyDO.setCreatorId(UserUtils.getLoginUser().getUserId());
                fundReportFrequencyDO.setUpdaterId(UserUtils.getLoginUser().getUserId());
                fundReportFrequencyDOList.add(fundReportFrequencyDO);
            }
            fundReportFrequencyMapper.insert(fundReportFrequencyDOList);
        }

        return vo;
    }

    @Override
    public ResultVo searchCompanyFrequency(CompanyIdVO companyIdVO) {
        ResultVo vo = new ResultVo(ResultCode.SAVE_SUCCESS.getCode());
        CompanyReportFrequencyDO companyFrequency = companyReportFrequencyMapper.getFrequencyByCompanyId(companyIdVO.getCompanyId());
        vo.setData(companyFrequency);
        return vo;
    }
}
